
// One chessboard, its history and current status.
class ttchess_chessboard {

	Integer address;
	ttchess_history history = new ttchess_history(this);  // previous moves
	ttchess_snapshot snapshot = new ttchess_snapshot(this);  // an empty board
	fenhax myFenhax = new fenhax();

	boolean alive;  // true if the board has replied to the latest pinging
	boolean dumped;  // true if the board has replied to the latest DGT_BUS_SEND_BRD
	boolean updated;  // true if the board has replied to the latest DGT_BUS_SEND_CHANGES
	ttchess_database db;  // the database that this board belongs to

	public ttchess_chessboard(Integer _address, ttchess_database _db) {
		address = _address;
		db = _db;
		alive = true;  // otherwise it would not have been created now
		dumped = false;
		updated = false;

		update_html();
	}

	ttchess_snapshot get_snapshot() { return snapshot; }

	int get_address() { return address.intValue(); }
	void set_alive(boolean x) { alive = x; update_html(); }
	void set_dumped(boolean x) { dumped = x; }
	void set_updated(boolean x) { updated = x; history.append(snapshot); }
	boolean get_alive() { return alive; }
	boolean get_dumped() { return dumped; }
	boolean get_updated() { return updated; }


//---- (2003-11-03) Klockan
	void set_clockdata(boolean running, boolean batteryLow, boolean frontViewLeftSideHigh,
		boolean blacksTurn, boolean whitesTurn, int secW, int secB) {

		snapshot.set_clockdata(running, batteryLow, frontViewLeftSideHigh, blacksTurn, whitesTurn, secW, secB);
		snapshot.debugprint_clock();
	}



	// Whenever a board has changed this method should be called to change
	// the html-files.
	void update_html() {

	    

		ttchess_mysql.update_snapshot(snapshot);


                String fen = ttchess_mysql.snapshot2fen(snapshot);

		myFenhax.add(fen);

		ttchess_mysql.update_moves(fenhax.getMoves(true,false), fenhax.getMoves(true,true), address.intValue());


		//fenhax.add(ttchess_mysql.snapshot2fen(snapshot));
		//ttchess_mysql.update_moves(fenhax.getMoveList(), fenhax.getMoveListTable(), address.intValue());
//                System.out.println("Board: "+address.intValue());
		//ttchess_html.print_snapshot(snapshot);
		//ttchess_html.print_index(db);
		//ttchess_html.print_history(history);
	}

	void set_emptyboard() {
		snapshot.set_emptyboard();
		history.append(snapshot);
//		if (ttchess.debug) snapshot.debugprint();
	}

	// Sets all 64 fields
	void set_boarddump(int[] all64, int startpos) {
		snapshot.set_boarddump(all64, startpos);
		dumped = true;  // mark that this board has received a dump message
		history.append(snapshot);
//		if (ttchess.debug) snapshot.debugprint();
	}

	// Sets 1 field
	void set_fieldupdate(int piece, int pos) {
		snapshot.set_fieldupdate(piece,pos);
		updated = true; // mark that this board has received a field message
		history.append(snapshot);
//		if (ttchess.debug) snapshot.debugprint();
	}
}
