
//import javax.comm.*;   // Windows
import gnu.io.*;     // GNU/Linux

import java.io.*;
import java.util.*;

// Low-level serial port communication.
class ttchess_serialport implements SerialPortEventListener {
	
	static CommPortIdentifier portid;
	
	InputStream inStream;
	OutputStream outStream;
	SerialPort serialPort;

	ttchess_receiver receiver;

	public ttchess_serialport(ttchess_receiver r) {
		receiver = r;
	}

	// Examples: "COM1", "/dev/term/a"
	public boolean open(String portname) {
	    //System.out.println("Tjo");

		CommPortIdentifier id = null;

		Enumeration portList;
		portList = CommPortIdentifier.getPortIdentifiers();
System.out.println(portList.toString());
		while (portList.hasMoreElements()) {
System.out.println("2");

			id = (CommPortIdentifier) portList.nextElement();
			if (id.getPortType() == CommPortIdentifier.PORT_SERIAL) {
System.out.println("Ports: "+id.getName());
				if (id.getName().equals(portname)) break;  // found
			}
			id = null;
		}
		if (id == null) return false;  // not found

		try {
			serialPort = (SerialPort) id.open("ttchess", 2000);
			inStream = serialPort.getInputStream();
			outStream = serialPort.getOutputStream();
			serialPort.addEventListener(this);
			serialPort.notifyOnDataAvailable(true);
			serialPort.setSerialPortParams(9600, SerialPort.DATABITS_8,
					SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
			
			// fix for multiple boards: one or two of RTS/DTR low for pull-down on RxD bus
			serialPort.setDTR(false);
			serialPort.setRTS(false);
		} catch (Exception e) { return false; }

		return true;
	}

	public boolean write(byte[] data) { // tip: If a String, use String.getBytes()

		// Print the message, for debugging
		char c[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
		StringBuffer x = new StringBuffer(" Sending: ");
		for (int i=0; i<data.length; i=i+1) {
			int d = data[i];
			if (d<0) d=256+d;
			x.append(c[d>>4]).append(c[d & 0x0F]).append(" ");
		}
		if (ttchess.debug) System.out.println(x.toString());

		try {
			outStream.write(data); 
		} catch (IOException e) { return false; }
		return true;
	}	

	// Implements the SerialPortEventListener interface
	public void serialEvent(SerialPortEvent event) {
		//System.out.println("Serial event!!");
		switch(event.getEventType()) {
		case SerialPortEvent.OUTPUT_BUFFER_EMPTY:
			break;
		case SerialPortEvent.DATA_AVAILABLE:
			byte[] readBuffer = new byte[200];
			try {
				while (inStream.available() > 0) {
					int numBytes = inStream.read(readBuffer);
					if (numBytes>0) {
						// convert to positive int because the STUPID java byte is signed.
						int[] buf = new int[numBytes];
						for (int i=0; i<numBytes; i=i+1) {
							int tmp = readBuffer[i];
							if (tmp<0) tmp=256+tmp;
							buf[i]=tmp;
						}
						receiver.receive(buf);
					}
				}
			} catch (IOException e) {}
			break;
		}
	}
}
